from .utils import board_to_int
from .Monoid import Monoid

_1    = Monoid(0, 0, 0, 0)
_A    = Monoid(1, 0, 0, 0)
_B    = Monoid(0, 1, 0, 0)
_AB   = Monoid(1, 1, 0, 0)
_B2   = Monoid(0, 2, 0, 0)
_AB2  = Monoid(1, 2, 0, 0)
_C    = Monoid(0, 0, 1, 0)
_AC   = Monoid(1, 0, 1, 0)
_BC   = Monoid(0, 1, 1, 0)
_ABC  = Monoid(1, 1, 1, 0)
_C2   = Monoid(0, 0, 2, 0)
_AC2  = Monoid(1, 0, 2, 0)
_BC2  = Monoid(0, 1, 2, 0)
_ABC2 = Monoid(1, 1, 2, 0)
_D    = Monoid(0, 0, 0, 1)
_AD   = Monoid(1, 0, 0, 1)
_BD   = Monoid(0, 1, 0, 1)
_ABD  = Monoid(1, 1, 0, 1)

PATTERN = {
    board_to_int([[0, 0, 0],
                  [0, 0, 0],
                  [0, 0, 0]]): _C,

    board_to_int([[1, 0, 0],
                  [0, 0, 0],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 0, 0],
                  [0, 0, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 0, 0],
                  [0, 0, 0]]): _AD,

    board_to_int([[0, 0, 1],
                  [0, 0, 0],
                  [0, 0, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 0, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [0, 0, 0],
                  [0, 0, 0]]): _AD,

    board_to_int([[1, 1, 1],
                  [0, 0, 0],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 0],
                  [0, 0, 0]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 0, 0],
                  [0, 0, 0]]): _AD,

    board_to_int([[0, 1, 0],
                  [1, 0, 0],
                  [0, 0, 0]]): _A,

    board_to_int([[1, 1, 0],
                  [1, 0, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[0, 0, 1],
                  [1, 0, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[1, 0, 1],
                  [1, 0, 0],
                  [0, 0, 0]]): _A,

    board_to_int([[0, 1, 1],
                  [1, 0, 0],
                  [0, 0, 0]]): _D,

    board_to_int([[1, 1, 1],
                  [1, 0, 0],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 0],
                  [0, 0, 0]]): _C2,

    board_to_int([[1, 0, 0],
                  [0, 1, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 1, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[1, 1, 0],
                  [0, 1, 0],
                  [0, 0, 0]]): _AB,

    board_to_int([[0, 0, 1],
                  [0, 1, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[1, 0, 1],
                  [0, 1, 0],
                  [0, 0, 0]]): _A,

    board_to_int([[0, 1, 1],
                  [0, 1, 0],
                  [0, 0, 0]]): _AB,
    
    board_to_int([[1, 1, 1],
                  [0, 1, 0],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[1, 0, 0],
                  [1, 1, 0],
                  [0, 0, 0]]): _AB,

    board_to_int([[0, 1, 0],
                  [1, 1, 0],
                  [0, 0, 0]]): _AB,

    board_to_int([[1, 1, 0],
                  [1, 1, 0],
                  [0, 0, 0]]): _A,

    board_to_int([[0, 0, 1],
                  [1, 1, 0],
                  [0, 0, 0]]): _A,

    board_to_int([[1, 0, 1],
                  [1, 1, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [1, 1, 0],
                  [0, 0, 0]]): _B,

    board_to_int([[1, 1, 1],
                  [1, 1, 0],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[1, 0, 0],
                  [0, 0, 1],
                  [0, 0, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 0, 1],
                  [0, 0, 0]]): _A,

    board_to_int([[1, 1, 0],
                  [0, 0, 1],
                  [0, 0, 0]]): _D,

    board_to_int([[0, 0, 1],
                  [0, 0, 1],
                  [0, 0, 0]]): _AD,

    board_to_int([[1, 0, 1],
                  [0, 0, 1],
                  [0, 0, 0]]): _A,

    board_to_int([[0, 1, 1],
                  [0, 0, 1],
                  [0, 0, 0]]): _B,

    board_to_int([[1, 1, 1],
                  [0, 0, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 1],
                  [0, 0, 0]]): _A,

    board_to_int([[1, 0, 0],
                  [1, 0, 1],
                  [0, 0, 0]]): _D,

    board_to_int([[0, 1, 0],
                  [1, 0, 1],
                  [0, 0, 0]]): _B,

    board_to_int([[1, 1, 0],
                  [1, 0, 1],
                  [0, 0, 0]]): _A,

    board_to_int([[0, 0, 1],
                  [1, 0, 1],
                  [0, 0, 0]]): _D,

    board_to_int([[1, 0, 1],
                  [1, 0, 1],
                  [0, 0, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [1, 0, 1],
                  [0, 0, 0]]): _A,

    board_to_int([[1, 1, 1],
                  [1, 0, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 1],
                  [0, 0, 0]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 1, 1],
                  [0, 0, 0]]): _A,

    board_to_int([[0, 1, 0],
                  [0, 1, 1],
                  [0, 0, 0]]): _AB,

    board_to_int([[1, 1, 0],
                  [0, 1, 1],
                  [0, 0, 0]]): _B,

    board_to_int([[0, 0, 1],
                  [0, 1, 1],
                  [0, 0, 0]]): _AB,

    board_to_int([[1, 0, 1],
                  [0, 1, 1],
                  [0, 0, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [0, 1, 1],
                  [0, 0, 0]]): _A,

    board_to_int([[1, 1, 1],
                  [0, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 1],
                  [0, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 0, 0],
                  [0, 0, 0],
                  [1, 0, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 0, 0],
                  [1, 0, 0]]): _B,

    board_to_int([[1, 1, 0],
                  [0, 0, 0],
                  [1, 0, 0]]): _A,

    board_to_int([[0, 0, 1],
                  [0, 0, 0],
                  [1, 0, 0]]): _A,

    board_to_int([[1, 0, 1],
                  [0, 0, 0],
                  [1, 0, 0]]): _AB,

    board_to_int([[0, 1, 1],
                  [0, 0, 0],
                  [1, 0, 0]]): _D,

    board_to_int([[1, 1, 1],
                  [0, 0, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 0],
                  [1, 0, 0]]): _AD,

    board_to_int([[1, 0, 0],
                  [1, 0, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 0, 0],
                  [1, 0, 0]]): _D,

    board_to_int([[1, 1, 0],
                  [1, 0, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 0, 0],
                  [1, 0, 0]]): _D,

    board_to_int([[1, 0, 1],
                  [1, 0, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 0],
                  [1, 0, 0]]): _AB,

    board_to_int([[1, 1, 1],
                  [1, 0, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 0],
                  [1, 0, 0]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 1, 0],
                  [1, 0, 0]]): _A,

    board_to_int([[0, 1, 0],
                  [0, 1, 0],
                  [1, 0, 0]]): _A,

    board_to_int([[1, 1, 0],
                  [0, 1, 0],
                  [1, 0, 0]]): _B,

    board_to_int([[0, 0, 1],
                  [0, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 0],
                  [1, 0, 0]]): _AB,

    board_to_int([[1, 0, 0],
                  [1, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 0],
                  [1, 0, 0]]): _B,

    board_to_int([[1, 1, 0],
                  [1, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 0],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 1],
                  [1, 0, 0]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 0, 1],
                  [1, 0, 0]]): _A,

    board_to_int([[0, 1, 0],
                  [0, 0, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 0, 1],
                  [1, 0, 0]]): _B,

    board_to_int([[0, 0, 1],
                  [0, 0, 1],
                  [1, 0, 0]]): _D,

    board_to_int([[1, 0, 1],
                  [0, 0, 1],
                  [1, 0, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [0, 0, 1],
                  [1, 0, 0]]): _A,

    board_to_int([[1, 1, 1],
                  [0, 0, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 1],
                  [1, 0, 0]]): _D,

    board_to_int([[1, 0, 0],
                  [1, 0, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 0, 1],
                  [1, 0, 0]]): _AB,

    board_to_int([[1, 1, 0],
                  [1, 0, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 0, 1],
                  [1, 0, 0]]): _A,

    board_to_int([[1, 0, 1],
                  [1, 0, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 1],
                  [1, 0, 0]]): _B,

    board_to_int([[1, 1, 1],
                  [1, 0, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 1],
                  [1, 0, 0]]): _A,

    board_to_int([[1, 0, 0],
                  [0, 1, 1],
                  [1, 0, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 1, 1],
                  [1, 0, 0]]): _B,

    board_to_int([[1, 1, 0],
                  [0, 1, 1],
                  [1, 0, 0]]): _A,

    board_to_int([[0, 0, 1],
                  [0, 1, 1],
                  [1, 0, 0]]): _A,

    board_to_int([[1, 0, 1],
                  [0, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 1],
                  [1, 0, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 0, 0],
                  [0, 0, 0],
                  [0, 1, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 0, 0],
                  [0, 1, 0]]): _A,

    board_to_int([[1, 1, 0],
                  [0, 0, 0],
                  [0, 1, 0]]): _D,

    board_to_int([[0, 0, 1],
                  [0, 0, 0],
                  [0, 1, 0]]): _B,

    board_to_int([[1, 0, 1],
                  [0, 0, 0],
                  [0, 1, 0]]): _A,

    board_to_int([[0, 1, 1],
                  [0, 0, 0],
                  [0, 1, 0]]): _D,

    board_to_int([[1, 1, 1],
                  [0, 0, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 0],
                  [0, 1, 0]]): _A,

    board_to_int([[1, 0, 0],
                  [1, 0, 0],
                  [0, 1, 0]]): _D,

    board_to_int([[0, 1, 0],
                  [1, 0, 0],
                  [0, 1, 0]]): _B,

    board_to_int([[1, 1, 0],
                  [1, 0, 0],
                  [0, 1, 0]]): _A,

    board_to_int([[0, 0, 1],
                  [1, 0, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 0, 0],
                  [0, 1, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [1, 0, 0],
                  [0, 1, 0]]): _AB,

    board_to_int([[1, 1, 1],
                  [1, 0, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 0],
                  [0, 1, 0]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 1, 0],
                  [0, 1, 0]]): _A,

    board_to_int([[0, 1, 0],
                  [0, 1, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 1, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 0],
                  [0, 1, 0]]): _A,

    board_to_int([[1, 0, 1],
                  [0, 1, 0],
                  [0, 1, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [0, 1, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 0],
                  [0, 1, 0]]): _AB,

    board_to_int([[1, 0, 0],
                  [1, 1, 0],
                  [0, 1, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [1, 1, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 0],
                  [0, 1, 0]]): _B,

    board_to_int([[1, 0, 1],
                  [1, 1, 0],
                  [0, 1, 0]]): _A,

    board_to_int([[0, 1, 1],
                  [1, 1, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 0],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 1],
                  [0, 1, 0]]): _A,

    board_to_int([[1, 0, 0],
                  [0, 0, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 0, 1],
                  [0, 1, 0]]): _B,

    board_to_int([[1, 1, 0],
                  [0, 0, 1],
                  [0, 1, 0]]): _AB,

    board_to_int([[0, 0, 1],
                  [0, 0, 1],
                  [0, 1, 0]]): _D,

    board_to_int([[1, 0, 1],
                  [0, 0, 1],
                  [0, 1, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [0, 0, 1],
                  [0, 1, 0]]): _A,

    board_to_int([[1, 1, 1],
                  [0, 0, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 1],
                  [0, 1, 0]]): _B,

    board_to_int([[1, 0, 0],
                  [1, 0, 1],
                  [0, 1, 0]]): _AB,

    board_to_int([[0, 1, 0],
                  [1, 0, 1],
                  [0, 1, 0]]): _A,

    board_to_int([[1, 1, 0],
                  [1, 0, 1],
                  [0, 1, 0]]): _B,

    board_to_int([[0, 0, 1],
                  [1, 0, 1],
                  [0, 1, 0]]): _AB,

    board_to_int([[1, 0, 1],
                  [1, 0, 1],
                  [0, 1, 0]]): _A,

    board_to_int([[0, 1, 1],
                  [1, 0, 1],
                  [0, 1, 0]]): _B,

    board_to_int([[1, 1, 1],
                  [1, 0, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 1],
                  [0, 1, 0]]): _AB,

    board_to_int([[1, 0, 0],
                  [0, 1, 1],
                  [0, 1, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 1],
                  [0, 1, 0]]): _B,

    board_to_int([[1, 0, 1],
                  [0, 1, 1],
                  [0, 1, 0]]): _A,

    board_to_int([[0, 1, 1],
                  [0, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 1],
                  [0, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 0],
                  [1, 1, 0]]): _AD,

    board_to_int([[1, 0, 0],
                  [0, 0, 0],
                  [1, 1, 0]]): _A,

    board_to_int([[0, 1, 0],
                  [0, 0, 0],
                  [1, 1, 0]]): _D,

    board_to_int([[1, 1, 0],
                  [0, 0, 0],
                  [1, 1, 0]]): _B,

    board_to_int([[0, 0, 1],
                  [0, 0, 0],
                  [1, 1, 0]]): _D,

    board_to_int([[1, 0, 1],
                  [0, 0, 0],
                  [1, 1, 0]]): _B,

    board_to_int([[0, 1, 1],
                  [0, 0, 0],
                  [1, 1, 0]]): _A,

    board_to_int([[1, 1, 1],
                  [0, 0, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 0],
                  [1, 1, 0]]): _B,

    board_to_int([[1, 0, 0],
                  [1, 0, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 0, 0],
                  [1, 1, 0]]): _A,

    board_to_int([[1, 1, 0],
                  [1, 0, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 0, 0],
                  [1, 1, 0]]): _A,

    board_to_int([[1, 0, 1],
                  [1, 0, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 0],
                  [1, 1, 0]]): _B,

    board_to_int([[1, 1, 1],
                  [1, 0, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 0],
                  [1, 1, 0]]): _AB,

    board_to_int([[1, 0, 0],
                  [0, 1, 0],
                  [1, 1, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 0],
                  [1, 1, 0]]): _A,

    board_to_int([[1, 0, 0],
                  [1, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 0],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 1],
                  [1, 1, 0]]): _D,

    board_to_int([[1, 0, 0],
                  [0, 0, 1],
                  [1, 1, 0]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 0, 1],
                  [1, 1, 0]]): _AB,

    board_to_int([[1, 1, 0],
                  [0, 0, 1],
                  [1, 1, 0]]): _A,

    board_to_int([[0, 0, 1],
                  [0, 0, 1],
                  [1, 1, 0]]): _AB,

    board_to_int([[1, 0, 1],
                  [0, 0, 1],
                  [1, 1, 0]]): _A,

    board_to_int([[0, 1, 1],
                  [0, 0, 1],
                  [1, 1, 0]]): _B,

    board_to_int([[1, 1, 1],
                  [0, 0, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 1],
                  [1, 1, 0]]): _A,

    board_to_int([[1, 0, 0],
                  [1, 0, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 0, 1],
                  [1, 1, 0]]): _B,

    board_to_int([[1, 1, 0],
                  [1, 0, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 0, 1],
                  [1, 1, 0]]): _B,

    board_to_int([[1, 0, 1],
                  [1, 0, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 1],
                  [1, 1, 0]]): _A,

    board_to_int([[1, 1, 1],
                  [1, 0, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 1],
                  [1, 1, 0]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 1, 1],
                  [1, 1, 0]]): _A,

    board_to_int([[0, 1, 0],
                  [0, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 1],
                  [1, 1, 0]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [0, 0, 0],
                  [0, 0, 1]]): _A,

    board_to_int([[0, 1, 0],
                  [0, 0, 0],
                  [0, 0, 1]]): _B,

    board_to_int([[1, 1, 0],
                  [0, 0, 0],
                  [0, 0, 1]]): _D,

    board_to_int([[0, 0, 1],
                  [0, 0, 0],
                  [0, 0, 1]]): _B,

    board_to_int([[1, 0, 1],
                  [0, 0, 0],
                  [0, 0, 1]]): _AB,

    board_to_int([[0, 1, 1],
                  [0, 0, 0],
                  [0, 0, 1]]): _A,

    board_to_int([[1, 1, 1],
                  [0, 0, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 0],
                  [0, 0, 1]]): _B,

    board_to_int([[1, 0, 0],
                  [1, 0, 0],
                  [0, 0, 1]]): _D,

    board_to_int([[0, 1, 0],
                  [1, 0, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 0, 0],
                  [0, 0, 1]]): _A,

    board_to_int([[0, 0, 1],
                  [1, 0, 0],
                  [0, 0, 1]]): _A,

    board_to_int([[1, 0, 1],
                  [1, 0, 0],
                  [0, 0, 1]]): _B,

    board_to_int([[0, 1, 1],
                  [1, 0, 0],
                  [0, 0, 1]]): _B,

    board_to_int([[1, 1, 1],
                  [1, 0, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 0],
                  [0, 0, 1]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 1, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 1, 0],
                  [0, 0, 1]]): _A,

    board_to_int([[1, 1, 0],
                  [0, 1, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 0],
                  [0, 0, 1]]): _A,

    board_to_int([[1, 0, 1],
                  [0, 1, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 0],
                  [0, 0, 1]]): _B,
    
    board_to_int([[1, 1, 1],
                  [0, 1, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 0],
                  [0, 0, 1]]): _A,

    board_to_int([[1, 0, 0],
                  [1, 1, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 0],
                  [0, 0, 1]]): _B,

    board_to_int([[1, 1, 0],
                  [1, 1, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 0],
                  [0, 0, 1]]): _B,

    board_to_int([[1, 0, 1],
                  [1, 1, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 0],
                  [0, 0, 1]]): _A,

    board_to_int([[1, 1, 1],
                  [1, 1, 0],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 1],
                  [0, 0, 1]]): _AD,

    board_to_int([[1, 0, 0],
                  [0, 0, 1],
                  [0, 0, 1]]): _D,

    board_to_int([[0, 1, 0],
                  [0, 0, 1],
                  [0, 0, 1]]): _D,

    board_to_int([[1, 1, 0],
                  [0, 0, 1],
                  [0, 0, 1]]): _AB,

    board_to_int([[0, 0, 1],
                  [0, 0, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 0, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 0, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 0, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 1],
                  [0, 0, 1]]): _D,

    board_to_int([[1, 0, 0],
                  [1, 0, 1],
                  [0, 0, 1]]): _A,

    board_to_int([[0, 1, 0],
                  [1, 0, 1],
                  [0, 0, 1]]): _AB,

    board_to_int([[1, 1, 0],
                  [1, 0, 1],
                  [0, 0, 1]]): _B,

    board_to_int([[0, 0, 1],
                  [1, 0, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 0, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 0, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 1],
                  [0, 0, 1]]): _AB,

    board_to_int([[1, 0, 0],
                  [0, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 1, 1],
                  [0, 0, 1]]): _B,

    board_to_int([[1, 1, 0],
                  [0, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 1],
                  [0, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 0],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 0, 0],
                  [1, 0, 1]]): _AB,

    board_to_int([[0, 1, 0],
                  [0, 0, 0],
                  [1, 0, 1]]): _A,

    board_to_int([[1, 1, 0],
                  [0, 0, 0],
                  [1, 0, 1]]): _B,

    board_to_int([[0, 0, 1],
                  [0, 0, 0],
                  [1, 0, 1]]): _AB,

    board_to_int([[1, 0, 1],
                  [0, 0, 0],
                  [1, 0, 1]]): _A,

    board_to_int([[0, 1, 1],
                  [0, 0, 0],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 1, 1],
                  [0, 0, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 0],
                  [1, 0, 1]]): _A,

    board_to_int([[1, 0, 0],
                  [1, 0, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 0, 0],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 1, 0],
                  [1, 0, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 0, 0],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 0, 1],
                  [1, 0, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 0],
                  [1, 0, 1]]): _A,

    board_to_int([[1, 1, 1],
                  [1, 0, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 0],
                  [1, 0, 1]]): _A,

    board_to_int([[1, 0, 0],
                  [0, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 1, 0],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 1, 0],
                  [0, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 0],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 0, 0],
                  [1, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 0],
                  [1, 0, 1]]): _A,

    board_to_int([[1, 1, 0],
                  [1, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 0],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 1],
                  [1, 0, 1]]): _A,

    board_to_int([[1, 0, 0],
                  [0, 0, 1],
                  [1, 0, 1]]): _B,

    board_to_int([[0, 1, 0],
                  [0, 0, 1],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 1, 0],
                  [0, 0, 1],
                  [1, 0, 1]]): _A,

    board_to_int([[0, 0, 1],
                  [0, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 1],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 0, 0],
                  [1, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 0, 1],
                  [1, 0, 1]]): _A,

    board_to_int([[1, 1, 0],
                  [1, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 0, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 1],
                  [1, 0, 1]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 1, 1],
                  [1, 0, 1]]): _A,

    board_to_int([[1, 1, 0],
                  [0, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 1],
                  [1, 0, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 0],
                  [0, 1, 1]]): _AD,

    board_to_int([[1, 0, 0],
                  [0, 0, 0],
                  [0, 1, 1]]): _D,

    board_to_int([[0, 1, 0],
                  [0, 0, 0],
                  [0, 1, 1]]): _D,

    board_to_int([[1, 1, 0],
                  [0, 0, 0],
                  [0, 1, 1]]): _A,

    board_to_int([[0, 0, 1],
                  [0, 0, 0],
                  [0, 1, 1]]): _A,

    board_to_int([[1, 0, 1],
                  [0, 0, 0],
                  [0, 1, 1]]): _B,

    board_to_int([[0, 1, 1],
                  [0, 0, 0],
                  [0, 1, 1]]): _B,

    board_to_int([[1, 1, 1],
                  [0, 0, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 0],
                  [0, 1, 1]]): _D,

    board_to_int([[1, 0, 0],
                  [1, 0, 0],
                  [0, 1, 1]]): _AB,

    board_to_int([[0, 1, 0],
                  [1, 0, 0],
                  [0, 1, 1]]): _AB,

    board_to_int([[1, 1, 0],
                  [1, 0, 0],
                  [0, 1, 1]]): _B,

    board_to_int([[0, 0, 1],
                  [1, 0, 0],
                  [0, 1, 1]]): _B,

    board_to_int([[1, 0, 1],
                  [1, 0, 0],
                  [0, 1, 1]]): _A,

    board_to_int([[0, 1, 1],
                  [1, 0, 0],
                  [0, 1, 1]]): _A,

    board_to_int([[1, 1, 1],
                  [1, 0, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 0],
                  [0, 1, 1]]): _AB,

    board_to_int([[1, 0, 0],
                  [0, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 0],
                  [0, 1, 1]]): _A,

    board_to_int([[1, 0, 1],
                  [0, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 0],
                  [0, 1, 1]]): _B,

    board_to_int([[1, 0, 0],
                  [1, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 0],
                  [0, 1, 1]]): _A,

    board_to_int([[1, 0, 1],
                  [1, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 0],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 1],
                  [0, 1, 1]]): _B,

    board_to_int([[1, 0, 0],
                  [0, 0, 1],
                  [0, 1, 1]]): _A,

    board_to_int([[0, 1, 0],
                  [0, 0, 1],
                  [0, 1, 1]]): _A,

    board_to_int([[1, 1, 0],
                  [0, 0, 1],
                  [0, 1, 1]]): _B,

    board_to_int([[0, 0, 1],
                  [0, 0, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 0, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 0, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 0, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 1],
                  [0, 1, 1]]): _A,

    board_to_int([[1, 0, 0],
                  [1, 0, 1],
                  [0, 1, 1]]): _B,

    board_to_int([[0, 1, 0],
                  [1, 0, 1],
                  [0, 1, 1]]): _B,

    board_to_int([[1, 1, 0],
                  [1, 0, 1],
                  [0, 1, 1]]): _A,

    board_to_int([[0, 0, 1],
                  [1, 0, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 0, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 0, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 1],
                  [0, 1, 1]]): _A,

    board_to_int([[1, 0, 0],
                  [0, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 1],
                  [0, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [0, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 0, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [0, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 0],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [0, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 0, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [0, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [0, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [0, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [0, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [0, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [0, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [0, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [0, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 0],
                  [1, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 0],
                  [1, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 0],
                  [1, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 0],
                  [1, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 0, 1],
                  [1, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 0, 1],
                  [1, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[0, 1, 1],
                  [1, 1, 1],
                  [1, 1, 1]]): _1,

    board_to_int([[1, 1, 1],
                  [1, 1, 1],
                  [1, 1, 1]]): _1,
}
